Package com.io7m.waxmill.xml.vm.v1

# Class WXM1PinCPUs

java.lang.Object
com.io7m.waxmill.xml.vm.v1.WXM1PinCPUs

All Implemented Interfaces:
  `WXM1PinCPUsType`

    public final class WXM1PinCPUs
    extends java.lang.Object
    implements WXM1PinCPUsType

Immutable implementation of `WXM1PinCPUsType`.

Use the builder to create immutable instances: `WXM1PinCPUs.builder()`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXM1PinCPUs.Builder` | Builds instances of type `WXM1PinCPUs`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXM1PinCPUs.Builder` | `builder()` | Creates a builder for `WXM1PinCPUs`.
  `static WXM1PinCPUs` | `copyOf​(WXM1PinCPUsType instance)` | Creates an immutable copy of a `WXM1PinCPUsType` value.
  `java.util.List<WXMPinCPU>` | `cpus()` |
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXM1PinCPUs` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `cpus`.
  `java.lang.String` | `toString()` | Prints the immutable value `WXM1PinCPUs` with attribute values.
  `WXM1PinCPUs` | `withCpus​(WXMPinCPU... elements)` | Copy the current immutable object with elements that replace the content of `cpus`.
  `WXM1PinCPUs` | `withCpus​(java.lang.Iterable<? extends WXMPinCPU> elements)` | Copy the current immutable object with elements that replace the content of `cpus`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### cpus

    public java.util.List<WXMPinCPU> cpus()
    Specified by:
      `cpus` in interface `WXM1PinCPUsType`
    Returns:
      The value of the `cpus` attribute

  - ### withCpus

    public final WXM1PinCPUs withCpus​(WXMPinCPU... elements)
    Copy the current immutable object with elements that replace the content of `cpus`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withCpus

    public final WXM1PinCPUs withCpus​(java.lang.Iterable<? extends WXMPinCPU> elements)
    Copy the current immutable object with elements that replace the content of `cpus`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of cpus elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXM1PinCPUs` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `cpus`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXM1PinCPUs` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXM1PinCPUs copyOf​(WXM1PinCPUsType instance)
    Creates an immutable copy of a `WXM1PinCPUsType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXM1PinCPUs instance

  - ### builder

    public static WXM1PinCPUs.Builder builder()
    Creates a builder for `WXM1PinCPUs`.

         WXM1PinCPUs.builder()
            .addCpus|addAllCpus(com.io7m.waxmill.machines.WXMPinCPU) // cpus elements
            .build();

    Returns:
      A new WXM1PinCPUs builder